{
  "codeTemplates": [
    {
      "type": "dbDDL",
      "applyFor": "85450995-2BDA-4C99-83EB-4D0FD91C368C",
      "isDefault": true,
      "createTable": "DROP TABLE IF EXISTS {{=it.entity.defKey}};\nCREATE TABLE {{=it.entity.defKey}}(\n{{ pkList = [] ; }}\n{{~it.entity.fields:field:index}}\n    {{? field.primaryKey }}{{ pkList.push(field.defKey) }}{{?}}\n    {{=field.defKey}} {{=field.type}}{{?field.len>0}}{{='('}}{{=field.len}}{{?field.scale>0}}{{=','}}{{=field.scale}}{{?}}{{=')'}}{{?}} {{= field.notNull ? 'NOT NULL' : '' }} {{= field.autoIncrement ? 'AUTO_INCREMENT' : '' }} {{= field.defaultValue ? it.func.join('DEFAULT',field.defaultValue,' ') : '' }} COMMENT '{{=it.func.join(field.defName,field.comment,';')}}' {{= index < it.entity.fields.length-1 ? ',' : ( pkList.length>0 ? ',' :'' ) }}\n{{~}}\n{{? pkList.length >0 }}\n    PRIMARY KEY ({{~pkList:pkName:i}}{{= pkName }}{{= i<pkList.length-1 ? ',' : '' }}{{~}})\n{{?}}\n)  COMMENT = '{{=it.func.join(it.entity.defName,it.entity.comment,';') }}';\n$blankline\n",
      "createIndex": "{{~ it.entity.indexes:index}}\nCREATE {{? index.unique}}UNIQUE {{?}}INDEX {{=index.defKey}} ON {{=it.entity.defKey}}({{ fieldsKeys = index.fields.map(function(field){return field.fieldDefKey}) ; }}{{=it.func.join(...fieldsKeys,',')}});\n{{~}}",
      "createView": "CREATE VIEW {{=it.view.defKey}} AS\nSELECT \n{{~it.view.fields:field:index}}\n    {{=field.refEntity}}.{{=field.refEntityField}} AS {{=field.defKey}}{{= index < it.view.fields.length-1 ? ',' : ''}}\n{{~}}\nFROM {{~it.view.refEntities:refEntity:index}}{{=refEntity}}{{= index < it.view.refEntities.length-1 ? ',' : ''}}{{~}};\n$blankline\n"
    },
    {
      "type": "dbDDL",
      "applyFor": "19C69802-5942-4E36-B970-97CA4B46D008",
      "isDefault": true,
      "createTable": "CREATE TABLE {{=it.entity.defKey}}(\n{{ pkList = [] ; }}\n{{~it.entity.fields:field:index}}\n    {{? field.primaryKey }}{{ pkList.push(field.defKey) }}{{?}}\n    {{=field.defKey}} {{=field.type}}{{?field.len>0}}{{='('}}{{=field.len}}{{?field.scale>0}}{{=','}}{{=field.scale}}{{?}}{{=')'}}{{?}}{{= field.defaultValue ? it.func.join(' DEFAULT ',field.defaultValue,' ') : '' }}{{= field.notNull ? ' NOT NULL' : '' }}{{= field.autoIncrement ? '' : '' }}{{= index < it.entity.fields.length-1 ? ',' : ( pkList.length>0 ? ',' :'' ) }}\n{{~}}\n{{? pkList.length >0 }}\n    PRIMARY KEY ({{~pkList:pkName:i}}{{= pkName }}{{= i<pkList.length-1 ? ',' : '' }}{{~}})\n{{?}}\n);\n$blankline\n{{? it.entity.defKey || it.entity.defName}}COMMENT ON TABLE {{=it.entity.defKey}} IS '{{=it.func.join(it.entity.defName,it.entity.comment,';')}}';{{?}}\n{{~it.entity.fields:field:index}}\n{{? field.defName || field.comment}}COMMENT ON COLUMN {{=it.entity.defKey}}.{{=field.defKey}} IS '{{=it.func.join(field.defName,field.comment,';')}}';{{?}}\n{{~}}",
      "createIndex": "{{~ it.entity.indexes:index}}\nCREATE {{? index.unique}}UNIQUE {{?}}INDEX {{=index.defKey}} ON {{=it.entity.defKey}}({{ fieldsKeys = index.fields.map(function(field){return field.fieldDefKey}) ; }}{{=it.func.join(...fieldsKeys,',')}});\n{{~}}",
      "createView": "CREATE VIEW {{=it.view.defKey}} AS\nSELECT \n{{~it.view.fields:field:index}}\n    {{=field.refEntity}}.{{=field.refEntityField}} AS {{=field.defKey}}{{= index < it.view.fields.length-1 ? ',' : ''}}\n{{~}}\nFROM {{~it.view.refEntities:refEntity:index}}{{=refEntity}}{{= index < it.view.refEntities.length-1 ? ',' : ''}}{{~}};\n$blankline\n"
    },
    {
      "type": "dbDDL",
      "applyFor": "3555C7AD-299D-45AD-BC76-DDE1ED1CC7AA",
      "isDefault": true,
      "createTable": "IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[{{=it.entity.defKey}}]') AND type in (N'U'))\nDROP TABLE [dbo].[{{=it.entity.defKey}}];\n\nCREATE TABLE [dbo].[{{=it.entity.defKey}}](\n{{ pkList = [] ; }}\n{{~it.entity.fields:field:index}}\n    {{? field.primaryKey }}{{ pkList.push(field.defKey) }}{{?}}\n    {{=field.defKey}} {{=field.type}}{{?field.len>0}}{{='('}}{{=field.len}}{{?field.scale>0}}{{=','}}{{=field.scale}}{{?}}{{=')'}}{{?}}{{= field.notNull ? ' NOT NULL' : '' }}{{= field.autoIncrement ? ' IDENTITY(1,1)' : '' }}{{= field.defaultValue ? it.func.join(' DEFAULT ',field.defaultValue,' ') : '' }}{{= index < it.entity.fields.length-1 ? ',' : ( pkList.length>0 ? ',' :'' ) }}\n{{~}}\n{{? pkList.length >0 }}\n    PRIMARY KEY ({{~pkList:pkName:i}}{{= pkName }}{{= i<pkList.length-1 ? ',' : '' }}{{~}})\n{{?}}\n){{=it.separator}}\n$blankline\n{{? it.entity.defKey || it.entity.defName}}EXEC sp_addextendedproperty 'MS_Description', '{{=it.func.join(it.entity.defName,it.entity.comment,';')}}', 'SCHEMA', dbo, 'table', {{=it.entity.defKey}}, null, null;{{?}}\n{{~it.entity.fields:field:index}}\nEXEC sp_addextendedproperty 'MS_Description', '{{=it.func.join(field.defName,field.comment,';')}}', 'SCHEMA', dbo, 'table', {{=it.entity.defKey}}, 'column', {{=field.defKey}};\n{{~}}\n",
      "createIndex": "{{~ it.entity.indexes:index}}\nCREATE {{? index.unique}}UNIQUE {{?}}INDEX {{=index.defKey}} ON {{=it.entity.defKey}}({{ fieldsKeys = index.fields.map(function(field){return field.fieldDefKey}) ; }}{{=it.func.join(...fieldsKeys,',')}});\n{{~}}",
      "createView": "CREATE VIEW {{=it.view.defKey}} AS\nSELECT \n{{~it.view.fields:field:index}}\n    {{=field.refEntity}}.{{=field.refEntityField}} AS {{=field.defKey}}{{= index < it.view.fields.length-1 ? ',' : ''}}\n{{~}}\nFROM {{~it.view.refEntities:refEntity:index}}{{=refEntity}}{{= index < it.view.refEntities.length-1 ? ',' : ''}}{{~}};\n$blankline\n"
    },
    {
      "type": "dbDDL",
      "applyFor": "409C9D49-7FD0-4183-B704-3A2475907B85",
      "isDefault": true,
      "createTable": "DROP TABLE IF EXISTS {{=it.entity.defKey}};\nCREATE TABLE {{=it.entity.defKey}}(\n{{ pkList = [] ; }}\n{{~it.entity.fields:field:index}}\n    {{? field.primaryKey }}{{ pkList.push(field.defKey) }}{{?}}\n    {{=field.defKey}} {{=field.type}}{{?field.len>0}}{{='('}}{{=field.len}}{{?field.scale>0}}{{=','}}{{=field.scale}}{{?}}{{=')'}}{{?}}{{= field.notNull ? ' NOT NULL' : '' }}{{= field.autoIncrement ? ' AUTO_INCREMENT' : '' }}{{= field.defaultValue ? it.func.join(' DEFAULT ',field.defaultValue,' ') : '' }}{{= index < it.entity.fields.length-1 ? ',' : ( pkList.length>0 ? ',' :'' ) }}\n{{~}}\n{{? pkList.length >0 }}\n    PRIMARY KEY ({{~pkList:pkName:i}}{{= pkName }}{{= i<pkList.length-1 ? ',' : '' }}{{~}})\n{{?}}\n);\n$blankline\n{{? it.entity.defKey || it.entity.defName}}COMMENT ON TABLE {{=it.entity.defKey}} IS '{{=it.func.join(it.entity.defName,it.entity.comment,';')}}';{{?}}\n{{~it.entity.fields:field:index}}\n{{? field.defName || field.comment}}COMMENT ON COLUMN {{=it.entity.defKey}}.{{=field.defKey}} IS '{{=it.func.join(field.defName,field.comment,';')}}';{{?}}\n{{~}}",
      "createIndex": "{{~ it.entity.indexes:index}}\nCREATE {{? index.unique}}UNIQUE {{?}}INDEX {{=index.defKey}} ON {{=it.entity.defKey}}({{ fieldsKeys = index.fields.map(function(field){return field.fieldDefKey}) ; }}{{=it.func.join(...fieldsKeys,',')}});\n{{~}}",
      "createView": "CREATE VIEW {{=it.view.defKey}} AS\nSELECT \n{{~it.view.fields:field:index}}\n    {{=field.refEntity}}.{{=field.refEntityField}} AS {{=field.defKey}}{{= index < it.view.fields.length-1 ? ',' : ''}}\n{{~}}\nFROM {{~it.view.refEntities:refEntity:index}}{{=refEntity}}{{= index < it.view.refEntities.length-1 ? ',' : ''}}{{~}};\n$blankline\n"
    },
    {
      "type": "appCode",
      "applyFor": "9474B191-5846-4032-A5B8-65AD575946B1",
      "isDefault": true,
      "content": "package cn.com.chiner.entity;\n$blankline\nimport javax.persistence.*;\nimport java.io.Serializable;\nimport java.util.Date;\n$blankline\n{{\n    var today=new Date();\n    var fullYear=today.getFullYear();\n    var month=today.getMonth() + 1;\n    var days=today.getDate();\n}}\n /**\n * @author : http://www.chiner.pro\n * @date : {{=fullYear}}-{{=month}}-{{=days}}\n * @desc : {{=it.func.join(it.entity.defName,it.entity.comment,'-')}}\n */\n@Table(name=\"{{=it.entity.defKey}}\")\npublic class {{=it.func.camel(it.entity.defKey,true) }} implements Serializable,Cloneable{\n{{~it.entity.fields:field:index}}\n    /** {{=it.func.join(field.defName,field.comment,';')}} */\n    {{? field.primaryKey }}\n    @Id\n    @GeneratedValue\n    {{?}}\n    private {{=field.type}} {{=it.func.camel(field.defKey,false)}} ;\n{{~}}\n$blankline\n\n{{~it.entity.fields:field:index}}\n    /** {{=it.func.join(field.defName,field.comment,';')}} */\n    public {{=field.type}} get{{=it.func.camel(field.defKey,true)}}(){\n        return this.{{=it.func.camel(field.defKey,false)}};\n    }\n    /** {{=it.func.join(field.defName,field.comment,';')}} */\n    public void set{{=it.func.camel(field.defKey,true)}}({{=field.type}} {{= it.func.camel(field.defKey,false) }}){\n        this.{{=it.func.camel(field.defKey,false)}}={{=it.func.camel(field.defKey,false)}};\n    }\n{{~}}\n}"
    },
    {
      "type": "dbDDL",
      "applyFor": "D3F96686-A8D3-40B9-B685-FFE9D36CBC3B",
      "isDefault": true,
      "createTable": "CREATE TABLE {{=it.entity.defKey}}(\n{{ pkList = [] ; }}\n{{~it.entity.fields:field:index}}\n    {{? field.primaryKey }}{{ pkList.push(field.defKey) }}{{?}}\n    {{=field.defKey}} {{=field.type}}{{?field.len>0}}{{='('}}{{=field.len}}{{?field.scale>0}}{{=','}}{{=field.scale}}{{?}}{{=')'}}{{?}}{{= field.notNull ? ' NOT NULL' : '' }}{{= field.autoIncrement ? '' : '' }}{{= field.defaultValue ? it.func.join(' DEFAULT ',field.defaultValue,' ') : '' }}{{= index < it.entity.fields.length-1 ? ',' : ( pkList.length>0 ? ',' :'' ) }}\n{{~}}\n{{? pkList.length >0 }}\n    PRIMARY KEY ({{~pkList:pkName:i}}{{= pkName }}{{= i<pkList.length-1 ? ',' : '' }}{{~}})\n{{?}}\n);\n$blankline\n{{? it.entity.defKey || it.entity.defName}}COMMENT ON TABLE {{=it.entity.defKey}} IS '{{=it.func.join(it.entity.defName,it.entity.comment,';')}}';{{?}}\n{{~it.entity.fields:field:index}}\n{{? field.defName || field.comment}}COMMENT ON COLUMN {{=it.entity.defKey}}.{{=field.defKey}} IS '{{=it.func.join(field.defName,field.comment,';')}}';{{?}}\n{{~}}",
      "createIndex": "{{~ it.entity.indexes:index}}\nCREATE {{? index.unique}}UNIQUE {{?}}INDEX {{=index.defKey}} ON {{=it.entity.defKey}}({{ fieldsKeys = index.fields.map(function(field){return field.fieldDefKey}) ; }}{{=it.func.join(...fieldsKeys,',')}});\n{{~}}",
      "createView": "CREATE VIEW {{=it.view.defKey}} AS\nSELECT \n{{~it.view.fields:field:index}}\n    {{=field.refEntity}}.{{=field.refEntityField}} AS {{=field.defKey}}{{= index < it.view.fields.length-1 ? ',' : ''}}\n{{~}}\nFROM {{~it.view.refEntities:refEntity:index}}{{=refEntity}}{{= index < it.view.refEntities.length-1 ? ',' : ''}}{{~}};\n$blankline\n"
    },
    {
      "type": "dbDDL",
      "applyFor": "06E6E496-6BAD-4BA5-9CA0-03EFA9388DA1",
      "isDefault": true,
      "createTable": "CREATE TABLE {{=it.entity.defKey}}(\n{{ pkList = [] ; }}\n{{~it.entity.fields:field:index}}\n    {{? field.primaryKey }}{{ pkList.push(field.defKey) }}{{?}}\n    {{=field.defKey}} {{=field.type}}{{?field.len>0}}{{='('}}{{=field.len}}{{?field.scale>0}}{{=','}}{{=field.scale}}{{?}}{{=')'}}{{?}}{{= field.notNull ? ' NOT NULL' : '' }}{{= field.autoIncrement ? '' : '' }}{{= field.defaultValue ? it.func.join(' DEFAULT ','('+field.defaultValue+')',' ') : '' }}{{= index < it.entity.fields.length-1 ? ',' : ( pkList.length>0 ? ',' :'' ) }}\n{{~}}\n{{? pkList.length >0 }}\n    PRIMARY KEY ({{~pkList:pkName:i}}{{= pkName }}{{= i<pkList.length-1 ? ',' : '' }}{{~}})\n{{?}}\n);\n$blankline\n{{? it.entity.defKey || it.entity.defName}}COMMENT ON TABLE {{=it.entity.defKey}} IS '{{=it.func.join(it.entity.defName,it.entity.comment,';')}}';{{?}}\n{{~it.entity.fields:field:index}}\n{{? field.defName || field.comment}}COMMENT ON COLUMN {{=it.entity.defKey}}.{{=field.defKey}} IS '{{=it.func.join(field.defName,field.comment,';')}}';{{?}}\n{{~}}",
      "createIndex": "{{~ it.entity.indexes:index}}\nCREATE {{? index.unique}}UNIQUE {{?}}INDEX {{=index.defKey}} ON {{=it.entity.defKey}}({{ fieldsKeys = index.fields.map(function(field){return field.fieldDefKey}) ; }}{{=it.func.join(...fieldsKeys,',')}});\n{{~}}",
      "createView": "CREATE VIEW {{=it.view.defKey}} AS\nSELECT \n{{~it.view.fields:field:index}}\n    {{=field.refEntity}}.{{=field.refEntityField}} AS {{=field.defKey}}{{= index < it.view.fields.length-1 ? ',' : ''}}\n{{~}}\nFROM {{~it.view.refEntities:refEntity:index}}{{=refEntity}}{{= index < it.view.refEntities.length-1 ? ',' : ''}}{{~}};\n$blankline\n"
    },
    {
      "type": "appCode",
      "applyFor": "51AA6EC9-FFC6-4ECC-8601-8483509E453B",
      "isDefault": true,
      "content": "using System;\nusing System.Collections.Generic;\n\n$blankline\n{{\n    var today=new Date();\n    var fullYear=today.getFullYear();\n    var month=today.getMonth() + 1;\n    var days=today.getDate();\n}}\n/*\n * @author : http://www.chiner.com.cn\n * @date : {{=fullYear}}-{{=month}}-{{=days}}\n * @desc : {{=it.func.join(it.entity.defName,it.entity.comment,'-')}}\n */\nnamespace Chiner.Application\n{\n    public partial class {{=it.func.camel(it.entity.defKey,true) }}\n    {\n    \n        {{~it.entity.fields:field:index}}\n        /// <summary>\n        /// {{=it.func.join(field.defName,field.comment,';')}}\n        /// </summary>\n        public {{=field.type}} {{=it.func.camel(field.defKey,true)}} { get; set; }\n        $blankline\n        {{~}}\n        \n    }\n}"
    },
    {
      "type": "dbDDL",
      "applyFor": "86690DD7-EBB5-45A3-A473-1E44F9846897",
      "isDefault": true,
      "createTable": "DROP TABLE IF EXISTS {{=it.entity.defKey}};\nCREATE TABLE {{=it.entity.defKey}}(\n{{ pkList = [] ; }}\n{{~it.entity.fields:field:index}}\n    {{? field.primaryKey }}{{ pkList.push(field.defKey) }}{{?}}\n    {{=field.defKey}} {{=field.type}}{{?field.len>0}}{{='('}}{{=field.len}}{{?field.scale>0}}{{=','}}{{=field.scale}}{{?}}{{=')'}}{{?}}{{= field.notNull ? ' NOT NULL' : '' }}{{= field.autoIncrement ? ' AUTO_INCREMENT' : '' }}{{= field.defaultValue ? it.func.join(' DEFAULT ',field.defaultValue,' ') : '' }}{{= index < it.entity.fields.length-1 ? ',' : ( pkList.length>0 ? ',' :'' ) }}\n{{~}}\n{{? pkList.length >0 }}\n    PRIMARY KEY ({{~pkList:pkName:i}}{{= pkName }}{{= i<pkList.length-1 ? ',' : '' }}{{~}})\n{{?}}\n);\n$blankline\n{{? it.entity.defKey || it.entity.defName}}COMMENT ON TABLE {{=it.entity.defKey}} IS '{{=it.func.join(it.entity.defName,it.entity.comment,';')}}';{{?}}\n{{~it.entity.fields:field:index}}\n{{? field.defName || field.comment}}COMMENT ON COLUMN {{=it.entity.defKey}}.{{=field.defKey}} IS '{{=it.func.join(field.defName,field.comment,';')}}';{{?}}\n{{~}}",
      "createIndex": "{{~ it.entity.indexes:index}}\nCREATE {{? index.unique}}UNIQUE {{?}}INDEX {{=index.defKey}} ON {{=it.entity.defKey}}({{ fieldsKeys = index.fields.map(function(field){return field.fieldDefKey}) ; }}{{=it.func.join(...fieldsKeys,',')}});\n{{~}}",
      "createView": "CREATE VIEW {{=it.view.defKey}} AS\nSELECT \n{{~it.view.fields:field:index}}\n    {{=field.refEntity}}.{{=field.refEntityField}} AS {{=field.defKey}}{{= index < it.view.fields.length-1 ? ',' : ''}}\n{{~}}\nFROM {{~it.view.refEntities:refEntity:index}}{{=refEntity}}{{= index < it.view.refEntities.length-1 ? ',' : ''}}{{~}};\n$blankline\n"
    },
    {
      "type": "dbDDL",
      "applyFor": "5ECA8850-94B0-490D-962D-87FCC34C9002",
      "isDefault": true,
      "createTable": "DROP TABLE IF EXISTS {{=it.entity.defKey}};\nCREATE TABLE {{=it.entity.defKey}}(\n{{ pkList = [] ; }}\n{{~it.entity.fields:field:index}}\n    {{? field.primaryKey }}{{ pkList.push(field.defKey) }}{{?}}\n    {{=field.defKey}} {{=field.type}}{{?field.len>0}}{{='('}}{{=field.len}}{{?field.scale>0}}{{=','}}{{=field.scale}}{{?}}{{=')'}}{{= field.defaultValue ? it.func.join(' DEFAULT ',field.defaultValue,' ') : '' }}{{?}}{{= field.notNull ? ' NOT NULL' : '' }}{{= index < it.entity.fields.length-1 ? ',' : ( pkList.length>0 ? ',' :'' ) }}\n{{~}}\n{{? pkList.length >0 }}\n    PRIMARY KEY ({{~pkList:pkName:i}}{{= pkName }}{{= i<pkList.length-1 ? ',' : '' }}{{~}})\n{{?}}\n);\n$blankline\n{{? it.entity.defKey || it.entity.defName}}COMMENT ON TABLE {{=it.entity.defKey}} IS '{{=it.func.join(it.entity.defName,it.entity.comment,';')}}';{{?}}\n{{~it.entity.fields:field:index}}\n{{? field.defName || field.comment}}COMMENT ON COLUMN {{=it.entity.defKey}}.{{=field.defKey}} IS '{{=it.func.join(field.defName,field.comment,';')}}';{{?}}\n{{~}}",
      "createIndex": "{{~ it.entity.indexes:index}}\nCREATE {{? index.unique}}UNIQUE {{?}}INDEX {{=index.defKey}} ON {{=it.entity.defKey}}({{ fieldsKeys = index.fields.map(function(field){return field.fieldDefKey}) ; }}{{=it.func.join(...fieldsKeys,',')}});\n{{~}}",
      "createView": "CREATE VIEW {{=it.view.defKey}} AS\nSELECT \n{{~it.view.fields:field:index}}\n    {{=field.refEntity}}.{{=field.refEntityField}} AS {{=field.defKey}}{{= index < it.view.fields.length-1 ? ',' : ''}}\n{{~}}\nFROM {{~it.view.refEntities:refEntity:index}}{{=refEntity}}{{= index < it.view.refEntities.length-1 ? ',' : ''}}{{~}};\n$blankline\n"
    },
    {
      "type": "dbDDL",
      "applyFor": "13698CD5-32FD-4442-8379-A9C360D2C9D6",
      "isDefault": true,
      "createTable": "DROP TABLE IF EXISTS {{=it.entity.defKey}};\nCREATE TABLE {{=it.entity.defKey}}(\n{{ pkList = [] ; }}\n{{~it.entity.fields:field:index}}\n    {{? field.primaryKey }}{{ pkList.push(field.defKey) }}{{?}}\n    {{=field.defKey}} {{=field.type}} {{= field.notNull ? 'NOT NULL' : '' }} {{= field.autoIncrement ? 'AUTO_INCREMENT' : '' }} {{= field.defaultValue ? it.func.join('DEFAULT',field.defaultValue,' ') : '' }} COMMENT '{{=it.func.join(field.defName,field.comment,';')}}' {{= index < it.entity.fields.length-1 ? ',' : ( pkList.length>0 ? ',' :'' ) }}\n{{~}}\n{{? pkList.length >0 }}\n    PRIMARY KEY ({{~pkList:pkName:i}}{{= pkName }}{{= i<pkList.length-1 ? ',' : '' }}{{~}})\n{{?}}\n)  COMMENT = '{{=it.func.join(it.entity.defName,it.entity.comment,';') }}';\n$blankline\n",
      "createIndex": "",
      "createView": "CREATE VIEW {{=it.view.defKey}} AS\nSELECT \n{{~it.view.fields:field:index}}\n    {{=field.refEntity}}.{{=field.refEntityField}} AS {{=field.defKey}}{{= index < it.view.fields.length-1 ? ',' : ''}}\n{{~}}\nFROM {{~it.view.refEntities:refEntity:index}}{{=refEntity}}{{= index < it.view.refEntities.length-1 ? ',' : ''}}{{~}};\n$blankline\n"
    },
    {
      "type": "dbDDL",
      "applyFor": "85450995-2BDA-4C99-83EB-4D0FD91C368C",
      "isDefault": true,
      "createTable": "DROP TABLE IF EXISTS {{=it.entity.defKey}};\nCREATE TABLE {{=it.entity.defKey}}(\n{{ pkList = [] ; }}\n{{~it.entity.fields:field:index}}\n    {{? field.primaryKey }}{{ pkList.push(field.defKey) }}{{?}}\n    {{=field.defKey}} {{=field.type}}{{?field.len>0}}{{='('}}{{=field.len}}{{?field.scale>0}}{{=','}}{{=field.scale}}{{?}}{{=')'}}{{?}} {{= field.notNull ? 'NOT NULL' : '' }} {{= field.autoIncrement ? 'AUTO_INCREMENT' : '' }} {{= field.defaultValue ? it.func.join('DEFAULT',field.defaultValue,' ') : '' }} COMMENT '{{=it.func.join(field.defName,field.comment,';')}}' {{= index < it.entity.fields.length-1 ? ',' : ( pkList.length>0 ? ',' :'' ) }}\n{{~}}\n{{? pkList.length >0 }}\n    PRIMARY KEY ({{~pkList:pkName:i}}{{= pkName }}{{= i<pkList.length-1 ? ',' : '' }}{{~}})\n{{?}}\n)  COMMENT = '{{=it.func.join(it.entity.defName,it.entity.comment,';') }}';\n$blankline\n",
      "createIndex": "{{~ it.entity.indexes:index}}\nCREATE {{? index.unique}}UNIQUE {{?}}INDEX {{=index.defKey}} ON {{=it.entity.defKey}}({{ fieldsKeys = index.fields.map(function(field){return field.fieldDefKey}) ; }}{{=it.func.join(...fieldsKeys,',')}});\n{{~}}",
      "createView": "CREATE VIEW {{=it.view.defKey}} AS\nSELECT \n{{~it.view.fields:field:index}}\n    {{=field.refEntity}}.{{=field.refEntityField}} AS {{=field.defKey}}{{= index < it.view.fields.length-1 ? ',' : ''}}\n{{~}}\nFROM {{~it.view.refEntities:refEntity:index}}{{=refEntity}}{{= index < it.view.refEntities.length-1 ? ',' : ''}}{{~}};\n$blankline\n"
    },
    {
      "type": "dbDDL",
      "applyFor": "19C69802-5942-4E36-B970-97CA4B46D008",
      "isDefault": true,
      "createTable": "CREATE TABLE {{=it.entity.defKey}}(\n{{ pkList = [] ; }}\n{{~it.entity.fields:field:index}}\n    {{? field.primaryKey }}{{ pkList.push(field.defKey) }}{{?}}\n    {{=field.defKey}} {{=field.type}}{{?field.len>0}}{{='('}}{{=field.len}}{{?field.scale>0}}{{=','}}{{=field.scale}}{{?}}{{=')'}}{{?}}{{= field.defaultValue ? it.func.join(' DEFAULT ',field.defaultValue,' ') : '' }}{{= field.notNull ? ' NOT NULL' : '' }}{{= field.autoIncrement ? '' : '' }}{{= index < it.entity.fields.length-1 ? ',' : ( pkList.length>0 ? ',' :'' ) }}\n{{~}}\n{{? pkList.length >0 }}\n    PRIMARY KEY ({{~pkList:pkName:i}}{{= pkName }}{{= i<pkList.length-1 ? ',' : '' }}{{~}})\n{{?}}\n);\n$blankline\n{{? it.entity.defKey || it.entity.defName}}COMMENT ON TABLE {{=it.entity.defKey}} IS '{{=it.func.join(it.entity.defName,it.entity.comment,';')}}';{{?}}\n{{~it.entity.fields:field:index}}\n{{? field.defName || field.comment}}COMMENT ON COLUMN {{=it.entity.defKey}}.{{=field.defKey}} IS '{{=it.func.join(field.defName,field.comment,';')}}';{{?}}\n{{~}}",
      "createIndex": "{{~ it.entity.indexes:index}}\nCREATE {{? index.unique}}UNIQUE {{?}}INDEX {{=index.defKey}} ON {{=it.entity.defKey}}({{ fieldsKeys = index.fields.map(function(field){return field.fieldDefKey}) ; }}{{=it.func.join(...fieldsKeys,',')}});\n{{~}}",
      "createView": "CREATE VIEW {{=it.view.defKey}} AS\nSELECT \n{{~it.view.fields:field:index}}\n    {{=field.refEntity}}.{{=field.refEntityField}} AS {{=field.defKey}}{{= index < it.view.fields.length-1 ? ',' : ''}}\n{{~}}\nFROM {{~it.view.refEntities:refEntity:index}}{{=refEntity}}{{= index < it.view.refEntities.length-1 ? ',' : ''}}{{~}};\n$blankline\n"
    },
    {
      "type": "dbDDL",
      "applyFor": "3555C7AD-299D-45AD-BC76-DDE1ED1CC7AA",
      "isDefault": true,
      "createTable": "IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[{{=it.entity.defKey}}]') AND type in (N'U'))\nDROP TABLE [dbo].[{{=it.entity.defKey}}];\n\nCREATE TABLE [dbo].[{{=it.entity.defKey}}](\n{{ pkList = [] ; }}\n{{~it.entity.fields:field:index}}\n    {{? field.primaryKey }}{{ pkList.push(field.defKey) }}{{?}}\n    {{=field.defKey}} {{=field.type}}{{?field.len>0}}{{='('}}{{=field.len}}{{?field.scale>0}}{{=','}}{{=field.scale}}{{?}}{{=')'}}{{?}}{{= field.notNull ? ' NOT NULL' : '' }}{{= field.autoIncrement ? ' IDENTITY(1,1)' : '' }}{{= field.defaultValue ? it.func.join(' DEFAULT ',field.defaultValue,' ') : '' }}{{= index < it.entity.fields.length-1 ? ',' : ( pkList.length>0 ? ',' :'' ) }}\n{{~}}\n{{? pkList.length >0 }}\n    PRIMARY KEY ({{~pkList:pkName:i}}{{= pkName }}{{= i<pkList.length-1 ? ',' : '' }}{{~}})\n{{?}}\n){{=it.separator}}\n$blankline\n{{? it.entity.defKey || it.entity.defName}}EXEC sp_addextendedproperty 'MS_Description', '{{=it.func.join(it.entity.defName,it.entity.comment,';')}}', 'SCHEMA', dbo, 'table', {{=it.entity.defKey}}, null, null;{{?}}\n{{~it.entity.fields:field:index}}\nEXEC sp_addextendedproperty 'MS_Description', '{{=it.func.join(field.defName,field.comment,';')}}', 'SCHEMA', dbo, 'table', {{=it.entity.defKey}}, 'column', {{=field.defKey}};\n{{~}}\n",
      "createIndex": "{{~ it.entity.indexes:index}}\nCREATE {{? index.unique}}UNIQUE {{?}}INDEX {{=index.defKey}} ON {{=it.entity.defKey}}({{ fieldsKeys = index.fields.map(function(field){return field.fieldDefKey}) ; }}{{=it.func.join(...fieldsKeys,',')}});\n{{~}}",
      "createView": "CREATE VIEW {{=it.view.defKey}} AS\nSELECT \n{{~it.view.fields:field:index}}\n    {{=field.refEntity}}.{{=field.refEntityField}} AS {{=field.defKey}}{{= index < it.view.fields.length-1 ? ',' : ''}}\n{{~}}\nFROM {{~it.view.refEntities:refEntity:index}}{{=refEntity}}{{= index < it.view.refEntities.length-1 ? ',' : ''}}{{~}};\n$blankline\n"
    },
    {
      "type": "dbDDL",
      "applyFor": "409C9D49-7FD0-4183-B704-3A2475907B85",
      "isDefault": true,
      "createTable": "DROP TABLE IF EXISTS {{=it.entity.defKey}};\nCREATE TABLE {{=it.entity.defKey}}(\n{{ pkList = [] ; }}\n{{~it.entity.fields:field:index}}\n    {{? field.primaryKey }}{{ pkList.push(field.defKey) }}{{?}}\n    {{=field.defKey}} {{=field.type}}{{?field.len>0}}{{='('}}{{=field.len}}{{?field.scale>0}}{{=','}}{{=field.scale}}{{?}}{{=')'}}{{?}}{{= field.notNull ? ' NOT NULL' : '' }}{{= field.autoIncrement ? ' AUTO_INCREMENT' : '' }}{{= field.defaultValue ? it.func.join(' DEFAULT ',field.defaultValue,' ') : '' }}{{= index < it.entity.fields.length-1 ? ',' : ( pkList.length>0 ? ',' :'' ) }}\n{{~}}\n{{? pkList.length >0 }}\n    PRIMARY KEY ({{~pkList:pkName:i}}{{= pkName }}{{= i<pkList.length-1 ? ',' : '' }}{{~}})\n{{?}}\n);\n$blankline\n{{? it.entity.defKey || it.entity.defName}}COMMENT ON TABLE {{=it.entity.defKey}} IS '{{=it.func.join(it.entity.defName,it.entity.comment,';')}}';{{?}}\n{{~it.entity.fields:field:index}}\n{{? field.defName || field.comment}}COMMENT ON COLUMN {{=it.entity.defKey}}.{{=field.defKey}} IS '{{=it.func.join(field.defName,field.comment,';')}}';{{?}}\n{{~}}",
      "createIndex": "{{~ it.entity.indexes:index}}\nCREATE {{? index.unique}}UNIQUE {{?}}INDEX {{=index.defKey}} ON {{=it.entity.defKey}}({{ fieldsKeys = index.fields.map(function(field){return field.fieldDefKey}) ; }}{{=it.func.join(...fieldsKeys,',')}});\n{{~}}",
      "createView": "CREATE VIEW {{=it.view.defKey}} AS\nSELECT \n{{~it.view.fields:field:index}}\n    {{=field.refEntity}}.{{=field.refEntityField}} AS {{=field.defKey}}{{= index < it.view.fields.length-1 ? ',' : ''}}\n{{~}}\nFROM {{~it.view.refEntities:refEntity:index}}{{=refEntity}}{{= index < it.view.refEntities.length-1 ? ',' : ''}}{{~}};\n$blankline\n"
    },
    {
      "type": "appCode",
      "applyFor": "9474B191-5846-4032-A5B8-65AD575946B1",
      "isDefault": true,
      "content": "package cn.com.chiner.entity;\n$blankline\nimport javax.persistence.*;\nimport java.io.Serializable;\nimport java.util.Date;\n$blankline\n{{\n    var today=new Date();\n    var fullYear=today.getFullYear();\n    var month=today.getMonth() + 1;\n    var days=today.getDate();\n}}\n /**\n * @author : http://www.chiner.pro\n * @date : {{=fullYear}}-{{=month}}-{{=days}}\n * @desc : {{=it.func.join(it.entity.defName,it.entity.comment,'-')}}\n */\n@Table(name=\"{{=it.entity.defKey}}\")\npublic class {{=it.func.camel(it.entity.defKey,true) }} implements Serializable,Cloneable{\n{{~it.entity.fields:field:index}}\n    /** {{=it.func.join(field.defName,field.comment,';')}} */\n    {{? field.primaryKey }}\n    @Id\n    @GeneratedValue\n    {{?}}\n    private {{=field.type}} {{=it.func.camel(field.defKey,false)}} ;\n{{~}}\n$blankline\n\n{{~it.entity.fields:field:index}}\n    /** {{=it.func.join(field.defName,field.comment,';')}} */\n    public {{=field.type}} get{{=it.func.camel(field.defKey,true)}}(){\n        return this.{{=it.func.camel(field.defKey,false)}};\n    }\n    /** {{=it.func.join(field.defName,field.comment,';')}} */\n    public void set{{=it.func.camel(field.defKey,true)}}({{=field.type}} {{= it.func.camel(field.defKey,false) }}){\n        this.{{=it.func.camel(field.defKey,false)}}={{=it.func.camel(field.defKey,false)}};\n    }\n{{~}}\n}"
    },
    {
      "type": "dbDDL",
      "applyFor": "D3F96686-A8D3-40B9-B685-FFE9D36CBC3B",
      "isDefault": true,
      "createTable": "CREATE TABLE {{=it.entity.defKey}}(\n{{ pkList = [] ; }}\n{{~it.entity.fields:field:index}}\n    {{? field.primaryKey }}{{ pkList.push(field.defKey) }}{{?}}\n    {{=field.defKey}} {{=field.type}}{{?field.len>0}}{{='('}}{{=field.len}}{{?field.scale>0}}{{=','}}{{=field.scale}}{{?}}{{=')'}}{{?}}{{= field.notNull ? ' NOT NULL' : '' }}{{= field.autoIncrement ? '' : '' }}{{= field.defaultValue ? it.func.join(' DEFAULT ',field.defaultValue,' ') : '' }}{{= index < it.entity.fields.length-1 ? ',' : ( pkList.length>0 ? ',' :'' ) }}\n{{~}}\n{{? pkList.length >0 }}\n    PRIMARY KEY ({{~pkList:pkName:i}}{{= pkName }}{{= i<pkList.length-1 ? ',' : '' }}{{~}})\n{{?}}\n);\n$blankline\n{{? it.entity.defKey || it.entity.defName}}COMMENT ON TABLE {{=it.entity.defKey}} IS '{{=it.func.join(it.entity.defName,it.entity.comment,';')}}';{{?}}\n{{~it.entity.fields:field:index}}\n{{? field.defName || field.comment}}COMMENT ON COLUMN {{=it.entity.defKey}}.{{=field.defKey}} IS '{{=it.func.join(field.defName,field.comment,';')}}';{{?}}\n{{~}}",
      "createIndex": "{{~ it.entity.indexes:index}}\nCREATE {{? index.unique}}UNIQUE {{?}}INDEX {{=index.defKey}} ON {{=it.entity.defKey}}({{ fieldsKeys = index.fields.map(function(field){return field.fieldDefKey}) ; }}{{=it.func.join(...fieldsKeys,',')}});\n{{~}}",
      "createView": "CREATE VIEW {{=it.view.defKey}} AS\nSELECT \n{{~it.view.fields:field:index}}\n    {{=field.refEntity}}.{{=field.refEntityField}} AS {{=field.defKey}}{{= index < it.view.fields.length-1 ? ',' : ''}}\n{{~}}\nFROM {{~it.view.refEntities:refEntity:index}}{{=refEntity}}{{= index < it.view.refEntities.length-1 ? ',' : ''}}{{~}};\n$blankline\n"
    },
    {
      "type": "dbDDL",
      "applyFor": "06E6E496-6BAD-4BA5-9CA0-03EFA9388DA1",
      "isDefault": true,
      "createTable": "CREATE TABLE {{=it.entity.defKey}}(\n{{ pkList = [] ; }}\n{{~it.entity.fields:field:index}}\n    {{? field.primaryKey }}{{ pkList.push(field.defKey) }}{{?}}\n    {{=field.defKey}} {{=field.type}}{{?field.len>0}}{{='('}}{{=field.len}}{{?field.scale>0}}{{=','}}{{=field.scale}}{{?}}{{=')'}}{{?}}{{= field.notNull ? ' NOT NULL' : '' }}{{= field.autoIncrement ? '' : '' }}{{= field.defaultValue ? it.func.join(' DEFAULT ','('+field.defaultValue+')',' ') : '' }}{{= index < it.entity.fields.length-1 ? ',' : ( pkList.length>0 ? ',' :'' ) }}\n{{~}}\n{{? pkList.length >0 }}\n    PRIMARY KEY ({{~pkList:pkName:i}}{{= pkName }}{{= i<pkList.length-1 ? ',' : '' }}{{~}})\n{{?}}\n);\n$blankline\n{{? it.entity.defKey || it.entity.defName}}COMMENT ON TABLE {{=it.entity.defKey}} IS '{{=it.func.join(it.entity.defName,it.entity.comment,';')}}';{{?}}\n{{~it.entity.fields:field:index}}\n{{? field.defName || field.comment}}COMMENT ON COLUMN {{=it.entity.defKey}}.{{=field.defKey}} IS '{{=it.func.join(field.defName,field.comment,';')}}';{{?}}\n{{~}}",
      "createIndex": "{{~ it.entity.indexes:index}}\nCREATE {{? index.unique}}UNIQUE {{?}}INDEX {{=index.defKey}} ON {{=it.entity.defKey}}({{ fieldsKeys = index.fields.map(function(field){return field.fieldDefKey}) ; }}{{=it.func.join(...fieldsKeys,',')}});\n{{~}}",
      "createView": "CREATE VIEW {{=it.view.defKey}} AS\nSELECT \n{{~it.view.fields:field:index}}\n    {{=field.refEntity}}.{{=field.refEntityField}} AS {{=field.defKey}}{{= index < it.view.fields.length-1 ? ',' : ''}}\n{{~}}\nFROM {{~it.view.refEntities:refEntity:index}}{{=refEntity}}{{= index < it.view.refEntities.length-1 ? ',' : ''}}{{~}};\n$blankline\n"
    },
    {
      "type": "appCode",
      "applyFor": "51AA6EC9-FFC6-4ECC-8601-8483509E453B",
      "isDefault": true,
      "content": "using System;\nusing System.Collections.Generic;\n\n$blankline\n{{\n    var today=new Date();\n    var fullYear=today.getFullYear();\n    var month=today.getMonth() + 1;\n    var days=today.getDate();\n}}\n/*\n * @author : http://www.chiner.com.cn\n * @date : {{=fullYear}}-{{=month}}-{{=days}}\n * @desc : {{=it.func.join(it.entity.defName,it.entity.comment,'-')}}\n */\nnamespace Chiner.Application\n{\n    public partial class {{=it.func.camel(it.entity.defKey,true) }}\n    {\n    \n        {{~it.entity.fields:field:index}}\n        /// <summary>\n        /// {{=it.func.join(field.defName,field.comment,';')}}\n        /// </summary>\n        public {{=field.type}} {{=it.func.camel(field.defKey,true)}} { get; set; }\n        $blankline\n        {{~}}\n        \n    }\n}"
    },
    {
      "type": "dbDDL",
      "applyFor": "86690DD7-EBB5-45A3-A473-1E44F9846897",
      "isDefault": true,
      "createTable": "DROP TABLE IF EXISTS {{=it.entity.defKey}};\nCREATE TABLE {{=it.entity.defKey}}(\n{{ pkList = [] ; }}\n{{~it.entity.fields:field:index}}\n    {{? field.primaryKey }}{{ pkList.push(field.defKey) }}{{?}}\n    {{=field.defKey}} {{=field.type}}{{?field.len>0}}{{='('}}{{=field.len}}{{?field.scale>0}}{{=','}}{{=field.scale}}{{?}}{{=')'}}{{?}}{{= field.notNull ? ' NOT NULL' : '' }}{{= field.autoIncrement ? ' AUTO_INCREMENT' : '' }}{{= field.defaultValue ? it.func.join(' DEFAULT ',field.defaultValue,' ') : '' }}{{= index < it.entity.fields.length-1 ? ',' : ( pkList.length>0 ? ',' :'' ) }}\n{{~}}\n{{? pkList.length >0 }}\n    PRIMARY KEY ({{~pkList:pkName:i}}{{= pkName }}{{= i<pkList.length-1 ? ',' : '' }}{{~}})\n{{?}}\n);\n$blankline\n{{? it.entity.defKey || it.entity.defName}}COMMENT ON TABLE {{=it.entity.defKey}} IS '{{=it.func.join(it.entity.defName,it.entity.comment,';')}}';{{?}}\n{{~it.entity.fields:field:index}}\n{{? field.defName || field.comment}}COMMENT ON COLUMN {{=it.entity.defKey}}.{{=field.defKey}} IS '{{=it.func.join(field.defName,field.comment,';')}}';{{?}}\n{{~}}",
      "createIndex": "{{~ it.entity.indexes:index}}\nCREATE {{? index.unique}}UNIQUE {{?}}INDEX {{=index.defKey}} ON {{=it.entity.defKey}}({{ fieldsKeys = index.fields.map(function(field){return field.fieldDefKey}) ; }}{{=it.func.join(...fieldsKeys,',')}});\n{{~}}",
      "createView": "CREATE VIEW {{=it.view.defKey}} AS\nSELECT \n{{~it.view.fields:field:index}}\n    {{=field.refEntity}}.{{=field.refEntityField}} AS {{=field.defKey}}{{= index < it.view.fields.length-1 ? ',' : ''}}\n{{~}}\nFROM {{~it.view.refEntities:refEntity:index}}{{=refEntity}}{{= index < it.view.refEntities.length-1 ? ',' : ''}}{{~}};\n$blankline\n"
    },
    {
      "type": "dbDDL",
      "applyFor": "5ECA8850-94B0-490D-962D-87FCC34C9002",
      "isDefault": true,
      "createTable": "DROP TABLE IF EXISTS {{=it.entity.defKey}};\nCREATE TABLE {{=it.entity.defKey}}(\n{{ pkList = [] ; }}\n{{~it.entity.fields:field:index}}\n    {{? field.primaryKey }}{{ pkList.push(field.defKey) }}{{?}}\n    {{=field.defKey}} {{=field.type}}{{?field.len>0}}{{='('}}{{=field.len}}{{?field.scale>0}}{{=','}}{{=field.scale}}{{?}}{{=')'}}{{= field.defaultValue ? it.func.join(' DEFAULT ',field.defaultValue,' ') : '' }}{{?}}{{= field.notNull ? ' NOT NULL' : '' }}{{= index < it.entity.fields.length-1 ? ',' : ( pkList.length>0 ? ',' :'' ) }}\n{{~}}\n{{? pkList.length >0 }}\n    PRIMARY KEY ({{~pkList:pkName:i}}{{= pkName }}{{= i<pkList.length-1 ? ',' : '' }}{{~}})\n{{?}}\n);\n$blankline\n{{? it.entity.defKey || it.entity.defName}}COMMENT ON TABLE {{=it.entity.defKey}} IS '{{=it.func.join(it.entity.defName,it.entity.comment,';')}}';{{?}}\n{{~it.entity.fields:field:index}}\n{{? field.defName || field.comment}}COMMENT ON COLUMN {{=it.entity.defKey}}.{{=field.defKey}} IS '{{=it.func.join(field.defName,field.comment,';')}}';{{?}}\n{{~}}",
      "createIndex": "{{~ it.entity.indexes:index}}\nCREATE {{? index.unique}}UNIQUE {{?}}INDEX {{=index.defKey}} ON {{=it.entity.defKey}}({{ fieldsKeys = index.fields.map(function(field){return field.fieldDefKey}) ; }}{{=it.func.join(...fieldsKeys,',')}});\n{{~}}",
      "createView": "CREATE VIEW {{=it.view.defKey}} AS\nSELECT \n{{~it.view.fields:field:index}}\n    {{=field.refEntity}}.{{=field.refEntityField}} AS {{=field.defKey}}{{= index < it.view.fields.length-1 ? ',' : ''}}\n{{~}}\nFROM {{~it.view.refEntities:refEntity:index}}{{=refEntity}}{{= index < it.view.refEntities.length-1 ? ',' : ''}}{{~}};\n$blankline\n"
    },
    {
      "type": "dbDDL",
      "applyFor": "13698CD5-32FD-4442-8379-A9C360D2C9D6",
      "isDefault": true,
      "createTable": "DROP TABLE IF EXISTS {{=it.entity.defKey}};\nCREATE TABLE {{=it.entity.defKey}}(\n{{ pkList = [] ; }}\n{{~it.entity.fields:field:index}}\n    {{? field.primaryKey }}{{ pkList.push(field.defKey) }}{{?}}\n    {{=field.defKey}} {{=field.type}} {{= field.notNull ? 'NOT NULL' : '' }} {{= field.autoIncrement ? 'AUTO_INCREMENT' : '' }} {{= field.defaultValue ? it.func.join('DEFAULT',field.defaultValue,' ') : '' }} COMMENT '{{=it.func.join(field.defName,field.comment,';')}}' {{= index < it.entity.fields.length-1 ? ',' : ( pkList.length>0 ? ',' :'' ) }}\n{{~}}\n{{? pkList.length >0 }}\n    PRIMARY KEY ({{~pkList:pkName:i}}{{= pkName }}{{= i<pkList.length-1 ? ',' : '' }}{{~}})\n{{?}}\n)  COMMENT = '{{=it.func.join(it.entity.defName,it.entity.comment,';') }}';\n$blankline\n",
      "createIndex": "",
      "createView": "CREATE VIEW {{=it.view.defKey}} AS\nSELECT \n{{~it.view.fields:field:index}}\n    {{=field.refEntity}}.{{=field.refEntityField}} AS {{=field.defKey}}{{= index < it.view.fields.length-1 ? ',' : ''}}\n{{~}}\nFROM {{~it.view.refEntities:refEntity:index}}{{=refEntity}}{{= index < it.view.refEntities.length-1 ? ',' : ''}}{{~}};\n$blankline\n"
    }
  ],
  "dataTypeSupports": [
    {
      "defKey": "MYSQL",
      "id": "85450995-2BDA-4C99-83EB-4D0FD91C368C"
    },
    {
      "defKey": "ORACLE",
      "id": "19C69802-5942-4E36-B970-97CA4B46D008"
    },
    {
      "defKey": "SQLServer",
      "id": "3555C7AD-299D-45AD-BC76-DDE1ED1CC7AA"
    },
    {
      "defKey": "PostgreSQL",
      "id": "409C9D49-7FD0-4183-B704-3A2475907B85"
    },
    {
      "defKey": "DB2",
      "id": "D3F96686-A8D3-40B9-B685-FFE9D36CBC3B"
    },
    {
      "defKey": "DM",
      "id": "06E6E496-6BAD-4BA5-9CA0-03EFA9388DA1"
    },
    {
      "defKey": "GaussDB",
      "id": "86690DD7-EBB5-45A3-A473-1E44F9846897"
    },
    {
      "defKey": "Kingbase",
      "id": "5ECA8850-94B0-490D-962D-87FCC34C9002"
    },
    {
      "defKey": "MaxCompute",
      "id": "13698CD5-32FD-4442-8379-A9C360D2C9D6"
    },
    {
      "defKey": "JAVA",
      "id": "9474B191-5846-4032-A5B8-65AD575946B1"
    },
    {
      "defKey": "C#",
      "id": "51AA6EC9-FFC6-4ECC-8601-8483509E453B"
    }
  ],
  "dataTypeMapping": {
    "referURL": "",
    "mappings": [
      {
        "defKey": "varchar",
        "defName": "varchar",
        "id": "76646D19-744F-4875-8B19-2996C9351721",
        "85450995-2BDA-4C99-83EB-4D0FD91C368C": "varchar",
        "19C69802-5942-4E36-B970-97CA4B46D008": "VARCHAR2",
        "3555C7AD-299D-45AD-BC76-DDE1ED1CC7AA": "VARCHAR",
        "409C9D49-7FD0-4183-B704-3A2475907B85": "VARCHAR",
        "D3F96686-A8D3-40B9-B685-FFE9D36CBC3B": "VARCHAR",
        "06E6E496-6BAD-4BA5-9CA0-03EFA9388DA1": "VARCHAR2",
        "86690DD7-EBB5-45A3-A473-1E44F9846897": "VARCHAR",
        "5ECA8850-94B0-490D-962D-87FCC34C9002": "VARCHAR",
        "13698CD5-32FD-4442-8379-A9C360D2C9D6": "STRING",
        "9474B191-5846-4032-A5B8-65AD575946B1": "String",
        "51AA6EC9-FFC6-4ECC-8601-8483509E453B": "string"
      },
      {
        "defKey": "double",
        "defName": "double",
        "id": "E0145AAD-7E53-48EE-9427-25B2C1DE81D9",
        "85450995-2BDA-4C99-83EB-4D0FD91C368C": "double",
        "19C69802-5942-4E36-B970-97CA4B46D008": "DECIMAL",
        "3555C7AD-299D-45AD-BC76-DDE1ED1CC7AA": "DECIMAL",
        "409C9D49-7FD0-4183-B704-3A2475907B85": "NUMERIC",
        "D3F96686-A8D3-40B9-B685-FFE9D36CBC3B": "DECIMAL",
        "06E6E496-6BAD-4BA5-9CA0-03EFA9388DA1": "DECIMAL",
        "86690DD7-EBB5-45A3-A473-1E44F9846897": "NUMERIC",
        "5ECA8850-94B0-490D-962D-87FCC34C9002": "NUMERIC",
        "13698CD5-32FD-4442-8379-A9C360D2C9D6": "DOUBLE",
        "9474B191-5846-4032-A5B8-65AD575946B1": "Double",
        "51AA6EC9-FFC6-4ECC-8601-8483509E453B": "float"
      },
      {
        "defKey": "int",
        "defName": "int",
        "id": "8A767580-9148-4E67-9D4B-3E6E83D6DA68",
        "85450995-2BDA-4C99-83EB-4D0FD91C368C": "int",
        "19C69802-5942-4E36-B970-97CA4B46D008": "INT",
        "3555C7AD-299D-45AD-BC76-DDE1ED1CC7AA": "INT",
        "409C9D49-7FD0-4183-B704-3A2475907B85": "INTEGER",
        "D3F96686-A8D3-40B9-B685-FFE9D36CBC3B": "INT",
        "06E6E496-6BAD-4BA5-9CA0-03EFA9388DA1": "INTEGER",
        "86690DD7-EBB5-45A3-A473-1E44F9846897": "INTEGER",
        "5ECA8850-94B0-490D-962D-87FCC34C9002": "INT4",
        "13698CD5-32FD-4442-8379-A9C360D2C9D6": "INT",
        "9474B191-5846-4032-A5B8-65AD575946B1": "Integer",
        "51AA6EC9-FFC6-4ECC-8601-8483509E453B": "float"
      },
      {
        "defKey": "datetime",
        "defName": "datetime",
        "id": "01B538C7-7ED2-409D-81A0-4D57FD6CAEDD",
        "85450995-2BDA-4C99-83EB-4D0FD91C368C": "datetime",
        "19C69802-5942-4E36-B970-97CA4B46D008": "DATE",
        "3555C7AD-299D-45AD-BC76-DDE1ED1CC7AA": "DATETIME",
        "409C9D49-7FD0-4183-B704-3A2475907B85": "DATE",
        "D3F96686-A8D3-40B9-B685-FFE9D36CBC3B": "DATE",
        "06E6E496-6BAD-4BA5-9CA0-03EFA9388DA1": "DATE",
        "86690DD7-EBB5-45A3-A473-1E44F9846897": "DATE",
        "5ECA8850-94B0-490D-962D-87FCC34C9002": "DATE",
        "13698CD5-32FD-4442-8379-A9C360D2C9D6": "DATETIME",
        "9474B191-5846-4032-A5B8-65AD575946B1": "Date",
        "51AA6EC9-FFC6-4ECC-8601-8483509E453B": "date"
      },
      {
        "defKey": "blob",
        "defName": "blob",
        "id": "F010B4C4-9B6E-4D7E-86CE-623FDD89BDBC",
        "85450995-2BDA-4C99-83EB-4D0FD91C368C": "BLOB",
        "19C69802-5942-4E36-B970-97CA4B46D008": "BLOB",
        "3555C7AD-299D-45AD-BC76-DDE1ED1CC7AA": "VARBINARY",
        "409C9D49-7FD0-4183-B704-3A2475907B85": "BYTEA",
        "D3F96686-A8D3-40B9-B685-FFE9D36CBC3B": "BLOB",
        "06E6E496-6BAD-4BA5-9CA0-03EFA9388DA1": "BLOB",
        "86690DD7-EBB5-45A3-A473-1E44F9846897": "BYTEA",
        "5ECA8850-94B0-490D-962D-87FCC34C9002": "BYTEA",
        "13698CD5-32FD-4442-8379-A9C360D2C9D6": "BINARY",
        "9474B191-5846-4032-A5B8-65AD575946B1": "byte[]",
        "51AA6EC9-FFC6-4ECC-8601-8483509E453B": "binary"
      },
      {
        "defKey": "text",
        "defName": "text",
        "id": "3653C7D4-313D-463D-94A9-71DBBB79247F",
        "85450995-2BDA-4C99-83EB-4D0FD91C368C": "text",
        "19C69802-5942-4E36-B970-97CA4B46D008": "CLOB",
        "3555C7AD-299D-45AD-BC76-DDE1ED1CC7AA": "TEXT",
        "409C9D49-7FD0-4183-B704-3A2475907B85": "TEXT",
        "D3F96686-A8D3-40B9-B685-FFE9D36CBC3B": "CLOB",
        "06E6E496-6BAD-4BA5-9CA0-03EFA9388DA1": "CLOB",
        "86690DD7-EBB5-45A3-A473-1E44F9846897": "TEXT",
        "5ECA8850-94B0-490D-962D-87FCC34C9002": "TEXT",
        "13698CD5-32FD-4442-8379-A9C360D2C9D6": "STRING",
        "9474B191-5846-4032-A5B8-65AD575946B1": "String",
        "51AA6EC9-FFC6-4ECC-8601-8483509E453B": "string"
      },
      {
        "defKey": "bigint",
        "defName": "bigint",
        "id": "38114558-1AAE-4CA0-ACB4-051DA7F61DE2",
        "85450995-2BDA-4C99-83EB-4D0FD91C368C": "bigint"
      },
      {
        "defKey": "tinyint",
        "defName": "tinyint",
        "id": "9BC5E4AC-C22E-4A67-8A75-04337CB45F17",
        "85450995-2BDA-4C99-83EB-4D0FD91C368C": "tinyint",
        "19C69802-5942-4E36-B970-97CA4B46D008": "tinyint",
        "3555C7AD-299D-45AD-BC76-DDE1ED1CC7AA": "tinyint",
        "409C9D49-7FD0-4183-B704-3A2475907B85": "tinyint",
        "D3F96686-A8D3-40B9-B685-FFE9D36CBC3B": "tinyint",
        "06E6E496-6BAD-4BA5-9CA0-03EFA9388DA1": "tinyint",
        "86690DD7-EBB5-45A3-A473-1E44F9846897": "VARCHAR",
        "5ECA8850-94B0-490D-962D-87FCC34C9002": "VARCHAR",
        "13698CD5-32FD-4442-8379-A9C360D2C9D6": "STRING",
        "9474B191-5846-4032-A5B8-65AD575946B1": "String",
        "51AA6EC9-FFC6-4ECC-8601-8483509E453B": "string"
      },
      {
        "defKey": "char",
        "defName": "char",
        "id": "C3368DC8-4E41-4DCA-9109-D6ECB4B351AA",
        "85450995-2BDA-4C99-83EB-4D0FD91C368C": "char"
      },
      {
        "defKey": "date",
        "defName": "date",
        "id": "9BAD165E-F85B-49A1-BE1E-46D15D0B9164",
        "85450995-2BDA-4C99-83EB-4D0FD91C368C": "date"
      },
      {
        "defKey": "decimal",
        "defName": "decimal",
        "id": "E96B77C5-0C67-4679-A1FC-17B8E388E1E0",
        "85450995-2BDA-4C99-83EB-4D0FD91C368C": "decimal"
      },
      {
        "defKey": "longtext",
        "defName": "longtext",
        "id": "0993489D-4745-4F42-B643-C99F142DB7BE",
        "85450995-2BDA-4C99-83EB-4D0FD91C368C": "longtext"
      },
      {
        "defKey": "mediumtext",
        "defName": "mediumtext",
        "id": "4798190F-6813-4E21-A0FE-7B5C9C6C29C0",
        "85450995-2BDA-4C99-83EB-4D0FD91C368C": "mediumtext"
      }
    ]
  },
  "domains": [
    {
      "defKey": "IdOrKey",
      "defName": "主键标识",
      "applyFor": "38114558-1AAE-4CA0-ACB4-051DA7F61DE2",
      "len": 32,
      "scale": "",
      "uiHint": "",
      "id": "5AE1CA9C-0FC0-4C7C-B3A7-83FAF26B9F72"
    },
    {
      "defKey": "Name",
      "defName": "名称",
      "applyFor": "76646D19-744F-4875-8B19-2996C9351721",
      "len": 90,
      "scale": "",
      "uiHint": "",
      "id": "954E7080-C6CB-4574-8F38-42B2F1283CE9"
    },
    {
      "defKey": "Int",
      "defName": "整数",
      "applyFor": "8A767580-9148-4E67-9D4B-3E6E83D6DA68",
      "len": "",
      "scale": "",
      "uiHint": "",
      "id": "E2A9DDB6-BF61-43F8-AD35-78065B35B9ED"
    },
    {
      "defKey": "Double",
      "defName": "小数",
      "applyFor": "E0145AAD-7E53-48EE-9427-25B2C1DE81D9",
      "len": 24,
      "scale": 6,
      "uiHint": "",
      "id": "AB9A5A29-964A-4572-8341-69B7F9E22A28"
    },
    {
      "defKey": "Money",
      "defName": "金额",
      "applyFor": "E0145AAD-7E53-48EE-9427-25B2C1DE81D9",
      "len": 28,
      "scale": 8,
      "uiHint": "",
      "id": "61B1F2D2-91B9-41BF-988D-2018231B4310"
    },
    {
      "defKey": "DateTime",
      "defName": "日期时间",
      "applyFor": "01B538C7-7ED2-409D-81A0-4D57FD6CAEDD",
      "len": "",
      "scale": "",
      "uiHint": "",
      "id": "1CD380DE-125A-4204-8F51-36D6BAA1598D"
    },
    {
      "defKey": "state",
      "defName": "状态值",
      "applyFor": "8A767580-9148-4E67-9D4B-3E6E83D6DA68",
      "len": "1",
      "scale": "",
      "uiHint": "",
      "id": "F0FB7A1D-1C37-47C1-8483-E6B4015B7561"
    },
    {
      "defKey": "Dict",
      "defName": "数据字典",
      "applyFor": "76646D19-744F-4875-8B19-2996C9351721",
      "len": "32",
      "scale": "",
      "uiHint": "",
      "id": "30DB072C-70F5-4ACC-B91F-6AF62FF4CD6E"
    },
    {
      "defKey": "DescText",
      "defName": "描述文本",
      "applyFor": "3653C7D4-313D-463D-94A9-71DBBB79247F",
      "len": "900",
      "scale": "",
      "uiHint": "",
      "id": "1D1F1F7E-FDB4-4C37-8B85-5FC24562CF4A"
    },
    {
      "defKey": "big_state",
      "defName": "大状态值",
      "applyFor": "8A767580-9148-4E67-9D4B-3E6E83D6DA68",
      "len": 10,
      "scale": "",
      "uiHint": "",
      "id": "58214932-CB59-4805-B0FA-6E957CB9C68D"
    },
    {
      "defKey": "企业及个人标识",
      "defName": "企业及个人标识",
      "applyFor": "38114558-1AAE-4CA0-ACB4-051DA7F61DE2",
      "len": 20,
      "scale": "",
      "uiHint": "",
      "id": "888E902B-67B3-4F9D-B545-02EA01418F26"
    },
    {
      "defKey": "YesNo",
      "defName": "是否",
      "applyFor": "9BC5E4AC-C22E-4A67-8A75-04337CB45F17",
      "len": "1",
      "scale": "",
      "uiHint": "",
      "id": "6D7A5B3B-1F52-49B1-B3BD-627A2D5B8D2A"
    },
    {
      "defKey": "varchar(30)",
      "defName": "varchar(30)",
      "applyFor": "76646D19-744F-4875-8B19-2996C9351721",
      "len": 30,
      "scale": "",
      "uiHint": "",
      "id": "E1CF0E45-37F8-4DBA-A276-407457CD9063"
    },
    {
      "defKey": "varchar(50)",
      "defName": "varchar(50)",
      "applyFor": "76646D19-744F-4875-8B19-2996C9351721",
      "len": 50,
      "scale": "",
      "uiHint": "",
      "id": "11210B09-0954-4289-AAB1-2D062D942518"
    },
    {
      "defKey": "varchar(100)",
      "defName": "varchar(100)",
      "applyFor": "76646D19-744F-4875-8B19-2996C9351721",
      "len": 100,
      "scale": "",
      "uiHint": "",
      "id": "057EB301-98EE-45D8-9FE1-6893BECF01DE"
    },
    {
      "defKey": "varchar(200)",
      "defName": "varchar(200)",
      "applyFor": "76646D19-744F-4875-8B19-2996C9351721",
      "len": 200,
      "scale": "",
      "uiHint": "",
      "id": "13389B8B-906F-4497-AE48-C21A6DDE6818"
    },
    {
      "defKey": "bigint(30)",
      "defName": "bigint(30)",
      "applyFor": "38114558-1AAE-4CA0-ACB4-051DA7F61DE2",
      "len": 30,
      "scale": "",
      "uiHint": "",
      "id": "1DF78950-B8EF-44C1-A4D8-7F3500D53F17"
    },
    {
      "defKey": "int(1)",
      "defName": "int(1)",
      "applyFor": "8A767580-9148-4E67-9D4B-3E6E83D6DA68",
      "len": 1,
      "scale": "",
      "uiHint": "",
      "id": "65280EE5-726F-449B-B6A7-4D90F045E067"
    },
    {
      "defKey": "datetime",
      "defName": "datetime",
      "applyFor": "01B538C7-7ED2-409D-81A0-4D57FD6CAEDD",
      "len": "",
      "scale": "",
      "uiHint": "",
      "id": "D15E3908-2412-4FED-B9B1-B002A84924EF"
    },
    {
      "defKey": "int(2)",
      "defName": "int(2)",
      "applyFor": "8A767580-9148-4E67-9D4B-3E6E83D6DA68",
      "len": 2,
      "scale": "",
      "uiHint": "",
      "id": "1E0BA777-C32B-4EB8-8F52-4B222A3301C4"
    },
    {
      "defKey": "int(10)",
      "defName": "int(10)",
      "applyFor": "8A767580-9148-4E67-9D4B-3E6E83D6DA68",
      "len": 10,
      "scale": "",
      "uiHint": "",
      "id": "759CB2D5-6340-4605-B7FA-9A58FF43F8C8"
    },
    {
      "defKey": "text",
      "defName": "text",
      "applyFor": "3653C7D4-313D-463D-94A9-71DBBB79247F",
      "len": "",
      "scale": "",
      "uiHint": "",
      "id": "DA3892E2-3263-41B2-8E55-EB74D3763BAE"
    },
    {
      "defKey": "double(28,8)",
      "defName": "double(28,8)",
      "applyFor": "E0145AAD-7E53-48EE-9427-25B2C1DE81D9",
      "len": 28,
      "scale": 8,
      "uiHint": "",
      "id": "DCA8171D-08AE-4A32-A6D0-BEE43CAC0B91"
    },
    {
      "defKey": "double(28,6)",
      "defName": "double(28,6)",
      "applyFor": "E0145AAD-7E53-48EE-9427-25B2C1DE81D9",
      "len": 28,
      "scale": 6,
      "uiHint": "",
      "id": "7C074ED8-EBAD-4D6F-A703-F3E8AA4A8EDF"
    },
    {
      "defKey": "remark",
      "defName": "备注",
      "applyFor": "76646D19-744F-4875-8B19-2996C9351721",
      "len": 200,
      "scale": "",
      "uiHint": "",
      "id": "1E0D0A76-452E-44F7-B6EB-D27AB95B68FA"
    },
    {
      "defKey": "企业及个人名称",
      "defName": "企业及个人名称",
      "applyFor": "76646D19-744F-4875-8B19-2996C9351721",
      "len": 32,
      "scale": "",
      "uiHint": "",
      "id": "65244FA1-A121-4FFB-A3E5-66DE0D541628"
    }
  ]
}